#ifndef EFL_GENERATED_EVAS_RECTANGLE_HH
#define EFL_GENERATED_EVAS_RECTANGLE_HH

#include <Eo.h>
#include <Eo.hh>

extern "C"
{
#include "canvas/evas_rectangle.eo.h"
}

#include "canvas/evas_object.eo.hh"

struct evas_rectangle
      : evas_object
{
   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit evas_rectangle(Eo* eo)
      : evas_object(eo)
   {}

   evas_rectangle(efl::eo::parent_type _p = (efl::eo::parent = nullptr))
      : evas_rectangle(_c0(_p))
   {}

   /// @brief Copy Constructor.
   ///
   evas_rectangle(evas_rectangle const& other)
      : evas_object(eo_ref(other._eo_ptr()))
   {}

   ~evas_rectangle() {}

   static Eo_Class const* _eo_class()
   {
      return(EVAS_OBJ_RECTANGLE_CLASS);
   }

private:
   static Eo* _c0(efl::eo::parent_type _p)
   {
      return eo_add_custom(EVAS_OBJ_RECTANGLE_CLASS, _p._eo_raw, eo_constructor());
   }

};
namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::evas_rectangle >
{
   template <typename T>
   struct type
   {
   };
};


template<>
struct operation_description_class_size< ::evas_rectangle >
{
   static const int value = 0;
};

template <typename T>
int initialize_operation_description(efl::eo::detail::tag<::evas_rectangle>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   return 0;
}
inline void
call_constructor(tag< ::evas_rectangle >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::evas_rectangle, ::std::tuple<> > const& args)
{
   (void)args;
   eo_do_super(eo, cls, ::eo_constructor());
}

template<>
struct extension_inheritance< ::evas_rectangle>
{
   template <typename T>
   struct type
   {
      operator ::evas_rectangle() const
      {
         return ::evas_rectangle(eo_ref(static_cast<T const*>(this)->_eo_ptr()));
      }

   };
};

inline Eo_Class const* get_eo_class(tag<::evas_rectangle>)
{
   return (EVAS_OBJ_RECTANGLE_CLASS);
}

} } }
#endif // EFL_GENERATED_EVAS_RECTANGLE_HH

